//========================================================================================
//
//	File:				Constant.h
//	Release Version:	$ 1.0d11 $
//
//	Author:				Henri Lamiraux
//
//	Copyright:	 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef CONSTANT_H
#define CONSTANT_H

// ----- OS Includes -----

#ifndef FWMNUITM_H
#include "FWMnuItm.h"
#endif

// ----- OpenDoc Includes -----

#ifndef _ODTYPES_
#include <ODTypes.h>
#endif

//========================================================================================
//	Constants
//========================================================================================

// ----- Commands -----
const ODCommandID cMoveForward		= FW_kFirstUserCommandID;
const ODCommandID cMoveToFront		= cMoveForward + 1;
const ODCommandID cMoveBackward		= cMoveToFront + 1;
const ODCommandID cMoveToBack 		= cMoveBackward + 1;
const ODCommandID cAlignToGrid		= cMoveToBack + 1;
const ODCommandID cAlignObjects		= cAlignToGrid + 1;
const ODCommandID cRotate 			= cAlignObjects + 1;
const ODCommandID cFlipH 			= cRotate + 1;
const ODCommandID cFlipV 			= cFlipH + 1;
const ODCommandID cGroup 			= cFlipV + 1;
const ODCommandID cUngroup 			= cGroup + 1;
const ODCommandID cLock 			= cUngroup + 1;
const ODCommandID cUnlock 			= cLock + 1;

const ODCommandID cPen1 			= cUnlock + 1;
const ODCommandID cPen2 			= cPen1+1;
const ODCommandID cPen3 			= cPen2+1;
const ODCommandID cPen4 			= cPen3+1;
const ODCommandID cPen5 			= cPen4+1;

const ODCommandID cGraphicsGrid		= cPen5 + 1;
const ODCommandID cRulers			= cGraphicsGrid + 1;
const ODCommandID cAutoGrid			= cRulers + 1;
const ODCommandID cScaleSelection	= cAutoGrid + 1;
const ODCommandID cRoundCorners		= cScaleSelection + 1;

const ODCommandID cInchUnit			= cRoundCorners + 1;
const ODCommandID cCmUnit			= cInchUnit + 1;
const ODCommandID cPixelUnit		= cCmUnit + 1;
const ODCommandID cPicaUnit			= cPixelUnit + 1;
const ODCommandID cDegreesUnit		= cPicaUnit + 1;
const ODCommandID cRadiansUnit		= cDegreesUnit + 1;

const ODCommandID cHideShowTools 	= cRadiansUnit + 1;
const ODCommandID cHideShowPattern	= cHideShowTools+1;
const ODCommandID cHideShowPalette	= cHideShowPattern+1;

// ----- Tool -----
const unsigned short kSelectTool 	= 1;
const unsigned short kLine 			= 2; 
const unsigned short kRectangle 	= 3; 
const unsigned short kOval 			= 4; 
const unsigned short kRoundRect 	= 5;
const unsigned short kText 			= 6;

// ----- Corner -----
const short kInTopLeftCorner = 1;
const short kInBottomRightCorner = kInTopLeftCorner + 1;
const short kInTopRightCorner = kInBottomRightCorner + 1;
const short kInBottomLeftCorner = kInTopRightCorner + 1;

// ----- Shape rendering -----
const unsigned short kFrameOnly = 1;
const unsigned short kFillOnly = 2;
const unsigned short kFillFrame = 3;


#endif