//========================================================================================
//
//	File:				DrawView.h
//	Release Version:	$ 1.0d11 $
//
//	Author:				Laurent Delamare
//
//	Copyright:	 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef DRAWVIEW_H
#define DRAWVIEW_H

// ----- Part Layer -----

#ifndef FWVIEW_H
#include "FWView.h"
#endif

//========================================================================================
// Forward Declaration
//========================================================================================

#if FW_LIB_EXPORT_PRAGMAS
#pragma import on
#endif
class FW_CLASS_ATTR FW_CGraphicContext;
#if FW_LIB_EXPORT_PRAGMAS
#pragma import off
#endif

class FW_CLASS_ATTR CDrawPart;
class FW_CLASS_ATTR CDrawFrame;
class FW_CLASS_ATTR CDrawSelection;

//========================================================================================
// Class CDrawView
//========================================================================================

class FW_CLASS_ATTR CDrawView : public FW_CView
{
public:
	FW_DECLARE_CLASS

//----------------------------------------------------------------------------------------
// Initialization/destruction
//
public:		
	CDrawView(Environment *ev, CDrawFrame* frame, FW_CRect& bounds, CDrawPart* drawPart);
	virtual ~ CDrawView();

//----------------------------------------------------------------------------------------
// Inherited API
//
public:		
	// -----
	virtual FW_Boolean		AdjustCursor(Environment *ev, ODFacet* facet, const FW_CPoint& where);
	
	// -----
	virtual void 			Draw(Environment *ev, ODFacet* odFacet, ODShape* invalidShape);

	// ----- Events -----
	virtual FW_Boolean		DoMouseDown(Environment *ev, const FW_CMouseEvent& theMouseEvent);
	virtual FW_Boolean		DoMouseDownInEmbeddedFrame(Environment* ev, const FW_CEmbeddedMouseEvent& theEmbeddedMouseEvent);
	virtual FW_Boolean		DoMouseDownInEmbeddedFrameBorder(Environment *ev, const FW_CBorderMouseEvent& theBorderMouseEvent);

	virtual FW_Boolean		Activate(Environment* ev);
	virtual void			Deactivate(Environment* ev);

//----------------------------------------------------------------------------------------
//	New API
//
protected:
	void					DrawGrid(Environment *ev, FW_CGraphicContext& gc, const FW_CRect& invalidRect);	

//----------------------------------------------------------------------------------------
// Data Members
//
private:	
	CDrawPart*				fDrawPart;
	CDrawFrame*				fDrawFrame;
};

#endif
