//========================================================================================
//
//	File:				EditCmds.h
//	Release Version:	$ 1.0d11 $
//
//	Author:				Henri Lamiraux
//
//	Copyright:	 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef EDITCMDS_H
#define EDITCMDS_H

// ----- Part Layer -----

#ifndef FWEDCMD_H
#include "FWEdCmd.h"
#endif

//========================================================================================
// Forward Declaration
//========================================================================================

#if FW_LIB_EXPORT_PRAGMAS
#pragma import on
#endif
class FW_CLASS_ATTR FW_CPrivOrderedCollection;
#if FW_LIB_EXPORT_PRAGMAS
#pragma import off
#endif

class FW_CLASS_ATTR CDrawPart;
class FW_CLASS_ATTR CDrawFrame;
class FW_CLASS_ATTR CDrawSelection;
class FW_CLASS_ATTR CDrawSubscribeLink;
class FW_CLASS_ATTR CDrawLinkManager;

//========================================================================================
// CDrawEditCommand
//========================================================================================

class FW_CLASS_ATTR CDrawEditCommand : public FW_CEditCommand
{
  public:

	CDrawEditCommand(Environment *ev, 
					 ODCommandID commandID,
					 CDrawPart* part, 
					 CDrawFrame* frame, 
					 CDrawSelection* selection,
					 FW_Boolean canUndo);

	virtual ~ CDrawEditCommand();

	// --- FW_CCommand overrides
	virtual void UndoIt(Environment *ev);			// Override
	virtual void RedoIt(Environment *ev);			// Override
	virtual void CommitUndone(Environment* ev);	// Override
	virtual void SaveUndoState(Environment *ev);	// Override
	virtual void SaveRedoState(Environment *ev);	// Override
	virtual void FreeUndoState(Environment *ev);	// Override
	virtual void FreeRedoState(Environment *ev);	// Override

	// ----- FW_CEditCommand overrides -----
	virtual void DoPaste(Environment *ev);	// Override
	virtual void DoPasteAs(Environment *ev);	// Override

  private:
	void SaveShapeSelection(Environment *ev);
	void RemoveShapeSelection(Environment *ev);
	void RestoreShapeSelection(Environment *ev);
	void SelectSavedShapes(Environment *ev);
	void DeleteSavedShapes(Environment *ev);

	CDrawLinkManager* GetDrawLinkManager(Environment* ev) const;

  private:
	CDrawPart*			fDrawPart;
	CDrawSelection*		fDrawSelection;
	FW_CPrivOrderedCollection* fShapeCollection;
	CDrawSubscribeLink*	fSavedLink;
};


#endif
