//========================================================================================
//
//	File:				TextShp.h
//	Release Version:	$ 1.0d11 $
//
//	Author:				Henri Lamiraux
//
//	Copyright:	 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef TEXTSHP_H
#define TEXTSHP_H

#ifndef CONSTANT_H
#include "Constant.h"
#endif

#ifndef BASESHP_H
#include "BaseShp.h"
#endif

#ifndef BOUNDSHP_H
#include "BoundShp.h"
#endif

// ----- Framework Layer -----

#ifndef FWSELECT_H
#include "FWSelect.h"
#endif

// ----- OS Layer -----

#ifndef FWINK_H
#include "FWInk.h"
#endif

#ifndef FWSTYLE_H
#include "FWStyle.h"
#endif

#ifndef FWPOINT_H
#include "FWPoint.h"
#endif

#ifndef FWRECT_H
#include "FWRect.h"
#endif

// ----- Foundation Layer -----

#ifndef FWRUNTYP_H
#include "FWRunTyp.h"
#endif

//========================================================================================
// Forward Declarations
//========================================================================================

/*#if FW_LIB_EXPORT_PRAGMAS
#pragma import on
#endif
class FW_CLASS_ATTR ODFacet;
class FW_CLASS_ATTR ODShape;
class FW_CLASS_ATTR CDrawPart;
class FW_CLASS_ATTR CDrawPublishLink;
class FW_CLASS_ATTR CDrawSubscribeLink;
class FW_CLASS_ATTR FW_CGraphicContext;
class FW_CLASS_ATTR FW_CMouseEvent;
class FW_CLASS_ATTR FW_CRectShape;
#if FW_LIB_EXPORT_PRAGMAS
#pragma import off
#endif*/

class FW_CLASS_ATTR CDrawFacetClipper;

//========================================================================================
// class CTextShape
//========================================================================================

class FW_CLASS_ATTR CTextShape : public CBoundedShape
{
public:
	FW_DECLARE_CLASS

public:
	CTextShape();
	CTextShape(FW_CReadableStream& archive);
	virtual ~CTextShape();
				
	// ----- Archiving -----
	static void* 		Read(FW_CReadableStream& archive);
	virtual void		Flatten(FW_CWritableStream& archive);
	
	// ----- Shape -----
	virtual void		GetClipRegion(Environment* ev, ODShape* clipRegion);
	virtual ODShape*	CreateShapeOutline(Environment *ev);
	
	virtual FW_Boolean	HitTest(Environment *ev, FW_CGraphicContext& gc, const FW_CMouseEvent& theMouseEvent) const;
	virtual void		RenderShape(Environment* ev, ODFacet* facet, FW_CGraphicContext& gc);

protected:
	CTextShape(unsigned short shapeType, unsigned short renderVerb);

private:
	virtual void 		OutlineShape(FW_CGraphicContext& gc, const FW_PInk& ink, const FW_PStyle& style, const FW_CRect& rect);
	FW_CDynamicString	fText;
};

#endif